﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Drawing;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Primitives;
using System.Collections;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {

        this.UltraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.BarChart;
        this.UltraChart1.DataSource = GetStackColumnData();
        this.UltraChart1.DataBind();
        this.UltraChart1.BarChart.NullHandling = NullHandling.DontPlot;
    }
    private DataTable GetStackColumnData()
    {
        DataTable mydata = new DataTable();
        // Define the columns and their names
        mydata.Columns.Add("Series Label", typeof(string));
        mydata.Columns.Add("Segment A", typeof(int));
       
        // Add the rows of data
        mydata.Rows.Add(new Object[] { "Stack A", 11});
        mydata.Rows.Add(new Object[] { "Stack B", 13});
        mydata.Rows.Add(new Object[] { "Stack C", 0 });
        mydata.Rows.Add(new Object[] { "Stack D", 7 });
        return mydata;
    }


    protected void UltraChart1_ChartDrawItem(object sender, Infragistics.UltraChart.Shared.Events.ChartDrawItemEventArgs e)
    {
       
    }
    protected void UltraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
    {
        ArrayList allBoxes = new ArrayList();
        foreach (Primitive p in e.SceneGraph)
        {
            Box b = p as Box;
            if (b != null)
            {
                if (b.rect.X != 0 && b.rect.Y != 0)
                {
                    allBoxes.Add(p);
                }
            }
        }

        foreach (Box b in allBoxes)
        {
            double boxValue = Convert.ToDouble(b.Value);
            LabelStyle labelStyle = new LabelStyle();

            SizeF labelSize = Infragistics.UltraChart.Core.Util.Platform.GetLabelSizePixels(b.Value.ToString(), labelStyle);
            int x = b.rect.X + b.rect.Width / 2 - (int)(labelSize.Width / 2);
            int y;
            int labelOffset = 2;
            if (boxValue != 0)
            {

                y = b.rect.Y - (int)labelSize.Height / 2 - labelOffset;
                Point textPoint = new Point(x, y);
                Text txtColumn = new Text(textPoint, b.Value.ToString(), labelStyle);
                e.SceneGraph.Add(txtColumn);

            }
        }
    }

   
}
